# -*- coding: utf-8 -*-

import codecs
import os

import object
import objectMap
import test
import squish


def dump_toplevel_objects(dump_systemtray_too=False):
    try:
        test.startSection("Dumping top level objects")
        test.log("Enabling real/symbol names in obj snapshots")
        f = codecs.open("%s/etc/qt_snapshot_filter.xml" % os.environ['SQUISH_PREFIX'], "r")
        s = f.read()
        f.close()
        s2 = s.replace('realname exclude="yes"/', 'realname exclude="no"/')
        s2 = s2.replace('symbolicname exclude="yes"/', 'symbolicname exclude="no"/')
        
        try:
            f = codecs.open("%s/etc/qt_snapshot_filter.xml" % os.environ['SQUISH_PREFIX'], "w")
            f.write(s2)
            f.close()
            test.log("Enabling real/symbol names in obj snapshots...done")
            
            squish.snooze(1)
            for count, o in enumerate(object.topLevelObjects()):
                cn = squish.className(o).split("_QMLTYPE_")[0]
                if cn == "SystemTray" and not dump_systemtray_too:
                    continue
                fn = "#%s_%s.object_xml" % (count, cn)
                test.log("Saving object snapshot: %s" % fn, objectMap.realName(o))
                try:
                    squish.saveObjectSnapshot(o, fn)
                except:
                    test.warning("Saving object snapshot failed: %s" % fn, objectMap.realName(o))
                    continue
                test.attachFile(fn, fn)
        finally:
            test.log("Disabling real/symbol names in obj snapshots...")
            f = codecs.open("%s/etc/qt_snapshot_filter.xml" % os.environ['SQUISH_PREFIX'], "w")
            f.write(s2)
            f.close()
            test.log("Disabling real/symbol names in obj snapshots...done")
    finally:
        test.endSection()
